<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>BallotDocumentationDataSource</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/operation/parameters/ballot-documentation/ballot-documentation-edit.component.ts</code>
        </p>


            <p class="comment">
                <h3>Extends</h3>
            </p>
            <p class="comment">
                    <code>DataSource</code>
            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#connect">connect</a>
                            </li>
                            <li>
                                <a href="#disconnect">disconnect</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(translateService: TranslateService, ballotDocumentations: <a href="../interfaces/BallotDocumentation.html">BallotDocumentation[]</a>, sort: MatSort)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="235" class="link-to-prism">src/app/operation/parameters/ballot-documentation/ballot-documentation-edit.component.ts:235</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>translateService</td>
                                                  
                                                        <td>
                                                                    <code>TranslateService</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>ballotDocumentations</td>
                                                  
                                                        <td>
                                                                    <code><a href="../interfaces/BallotDocumentation.html" target="_self" >BallotDocumentation[]</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>sort</td>
                                                  
                                                        <td>
                                                                    <code>MatSort</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>


            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="connect"></a>
                        <span class="name">
                            <b>
                            connect
                            </b>
                            <a href="#connect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>connect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="242" class="link-to-prism">src/app/operation/parameters/ballot-documentation/ballot-documentation-edit.component.ts:242</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="../interfaces/BallotDocumentation.html" target="_self" >Observable&lt;BallotDocumentation[]&gt;</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="disconnect"></a>
                        <span class="name">
                            <b>
                            disconnect
                            </b>
                            <a href="#disconnect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>disconnect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="255" class="link-to-prism">src/app/operation/parameters/ballot-documentation/ballot-documentation-edit.component.ts:255</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnDestroy, OnInit, ViewChild } from &#x27;@angular/core&#x27;;
import { Operation } from &#x27;../../model/operation&#x27;;
import { MatSnackBar, MatSort, MatSortable } from &#x27;@angular/material&#x27;;
import { DataSource } from &#x27;@angular/cdk/collections&#x27;;
import { Observable } from &#x27;rxjs/Observable&#x27;;
import { sortOnProperty } from &#x27;../../../core/util/table-utils&#x27;;
import { BallotDocumentationService } from &#x27;./service/ballot-documentation.service&#x27;;
import { FileService } from &#x27;../../../core/service/file-service/file-service&#x27;;
import { TdDialogService } from &#x27;@covalent/core&#x27;;
import { TranslateService } from &#x27;@ngx-translate/core&#x27;;
import { map, merge } from &#x27;rxjs/operators&#x27;;
import { AuthorizationService } from &#x27;../../../core/service/http/authorization.service&#x27;;
import { ConfirmBeforeQuit } from &#x27;../../../core/confirm-before-quit&#x27;;
import { UploadInputComponent } from &#x27;../../../shared/upload-input/upload-input.component&#x27;;
import { Subscription } from &#x27;rxjs/Subscription&#x27;;
import { ReadOnlyService } from &#x27;../../service/read-only.service&#x27;;
import { BallotDocumentation } from &#x27;./model/ballot-documentation&#x27;;
import { FormBuilder, FormGroup, Validators } from &#x27;@angular/forms&#x27;;
import { OperationManagementService } from &#x27;../../service/operation-managment.service&#x27;;
import { of } from &#x27;rxjs/observable/of&#x27;;
import { OperationDataService } from &#x27;../../service/operation.data.service&#x27;;
import { isFormModifiedAndNotSaved } from &#x27;../../../core/util/form-utils&#x27;;


const ALL_LANGUAGES &#x3D; [
  {value: &#x27;DE&#x27;, labelKey: &#x27;parameters.ballot-documentation.edit.form.fields.language.label-key.DE&#x27;},
  {value: &#x27;FR&#x27;, labelKey: &#x27;parameters.ballot-documentation.edit.form.fields.language.label-key.FR&#x27;},
  {value: &#x27;IT&#x27;, labelKey: &#x27;parameters.ballot-documentation.edit.form.fields.language.label-key.IT&#x27;},
  {value: &#x27;RM&#x27;, labelKey: &#x27;parameters.ballot-documentation.edit.form.fields.language.label-key.RM&#x27;}
];


@Component({
  templateUrl: &#x27;./ballot-documentation-edit.component.html&#x27;,
  styleUrls: [&#x27;../parameter-edit.scss&#x27;, &#x27;./ballot-documentation-edit.component.scss&#x27;]
})
export class BallotDocumentationEditComponent implements OnInit, OnDestroy, ConfirmBeforeQuit {
  private _subscriptions: Subscription[] &#x3D; [];
  private _readOnly &#x3D; false;

  allBallots &#x3D; [];
  possibleBallots &#x3D; [];
  possibleLanguages &#x3D; [];
  duplicateFile: string;
  operation: Operation;
  ballotDocumentations: BallotDocumentation[] &#x3D; [];
  dataSource: BallotDocumentationDataSource;
  @ViewChild(UploadInputComponent)
  uploadInputComponent: UploadInputComponent;
  @ViewChild(MatSort) sort: MatSort;
  form: FormGroup;


  constructor(fb: FormBuilder,
              private operationManagementService: OperationManagementService,
              private ballotDocumentationService: BallotDocumentationService,
              private operationDataService: OperationDataService,
              private fileService: FileService,
              private dialogService: TdDialogService,
              private translateService: TranslateService,
              private authorizationService: AuthorizationService,
              private readOnlyService: ReadOnlyService,
              private snackBar: MatSnackBar) {


    this.form &#x3D; fb.group({
        localizedLabel: [null, [Validators.required, Validators.maxLength(30)]],
        ballotId: [null, [Validators.required,]],
        language: [null, [Validators.required,]],
      },
      {validator: this.labelExistenceValidator(&#x27;localizedLabel&#x27;, &#x27;ballotId&#x27;, &#x27;language&#x27;)}
    );

  }

  /**
   * This validator is to check that file label is unique for the same ballot and language
   * @param localizedLabel
   * @param ballotId
   * @param language
   */
  labelExistenceValidator(localizedLabel: string, ballotId: string, language: string) {

    return (group: FormGroup): { [key: string]: any } &#x3D;&gt; {
      let selectedLocalizedLabel &#x3D; group.controls[localizedLabel].value;
      let selectedBallot &#x3D; group.controls[ballotId].value;
      let selectedLanguage &#x3D; group.controls[language].value;

      for (let bd of  this.ballotDocumentations) {
        if (bd.ballotId &#x3D;&#x3D;&#x3D; selectedBallot &amp;&amp; bd.language &#x3D;&#x3D;&#x3D; selectedLanguage &amp;&amp;
            bd.localizedLabel &#x3D;&#x3D;&#x3D; selectedLocalizedLabel) {
          this.duplicateFile &#x3D; this.translateService.instant(
            &#x60;parameters.ballot-documentation.edit.form.duplicate-localized-label&#x60;,
            {language: selectedLanguage, ballotId: selectedBallot});
          return {labelExists: true};
        }
      }
      return null;
    }
  }

  ngOnInit() {
    this._subscriptions.push(
      this.operationManagementService.operation.subscribe(operation &#x3D;&gt; {
          this.operation &#x3D; operation;
          this.ballotDocumentationService.list(operation.id)
            .subscribe(ballotDocumentations &#x3D;&gt; this.updateDataSource(ballotDocumentations));

          this.operationDataService.getAllRelatedBallots(operation.id, true, true)
            .subscribe(ballots &#x3D;&gt; {
              this.allBallots &#x3D; ballots;
              this.updatePossibleBallots();
            });

        }
      ),
      this.readOnlyService.isRepositoryInReadOnly()
        .subscribe(
          readOnly &#x3D;&gt; {
            this._readOnly &#x3D; readOnly;
          }
        ),
    );

    //The first sort is done on ballotId column
    // To conform to the SFD, the second column to be sorted is language but matsort doesn&#x27;t support this feature yet.
    // An issue is opened for this purpose
    // TODO : https://github.com/angular/material2/issues/7226
    this.sort.sort(&lt;MatSortable&gt;{
        id: &quot;ballotId&quot;,
        start: &quot;asc&quot;,
      }
    );
  }

  get readOnly() {
    return this._readOnly;
  }

  get displayedColumns() {
    let readableColumn &#x3D; [&#x27;managementEntity&#x27;, &#x27;ballotId&#x27;, &#x27;file&#x27;, &#x27;localizedLabel&#x27;, &quot;language&quot;];
    if (this.readOnly || !this.authorizationService.hasAtLeastOneRole([&quot;DELETE_BALLOT_DOCUMENTATION&quot;])) {
      return readableColumn;
    }
    return readableColumn.concat([&#x27;delete&#x27;]);
  }

  get uploadUrl() {
    return this.ballotDocumentationService.serviceUrl(this.operation.id) + &quot;?&quot; +
           &quot;localizedLabel&#x3D;&quot; + encodeURIComponent(this.form.value.localizedLabel) + &quot;&amp;&quot; +
           &quot;language&#x3D;&quot; + encodeURIComponent(this.form.value.language) + &quot;&amp;&quot; +
           &quot;ballotId&#x3D;&quot; + encodeURIComponent(this.form.value.ballotId);
  }

  updatePossibleBallots() {
    this.possibleBallots &#x3D; this.allBallots;
  }

  updatePossibleLanguages() {
    this.possibleLanguages &#x3D; ALL_LANGUAGES;
  }

  checkBeforeUpload() {
    return () &#x3D;&gt; {
      this.form.controls.localizedLabel.markAsTouched();
      this.form.controls.ballotId.markAsTouched();
      this.form.controls.language.markAsTouched();
      this.form.updateValueAndValidity();
      return this.form.valid;
    }
  }

  ngOnDestroy(): void {
    this._subscriptions.forEach(s &#x3D;&gt; s.unsubscribe());
  }


  updateDataSource(ballotDocumentations) {
    this.ballotDocumentations &#x3D; ballotDocumentations;
    this.form.reset({localizedLabel: null, ballotId: null, language: null});
    this.updatePossibleLanguages();
    this.updatePossibleBallots();
    this.dataSource &#x3D; new BallotDocumentationDataSource(this.translateService, this.ballotDocumentations, this.sort);
  }

  isFormModified(): boolean {
    return this.uploadInputComponent &amp;&amp; this.uploadInputComponent.isFormModified() ||
           isFormModifiedAndNotSaved(this.form, false);
  }

  processUploadResult(result: BallotDocumentation) {
    this.snackBar.open(
      this.translateService.instant(&#x27;parameters.ballot-documentation.edit.form.import-success&#x27;),
      &#x27;&#x27;, {duration: 5000}
    );

    this.updateDataSource([...this.ballotDocumentations, result]);
  }

  download(e, element: BallotDocumentation) {
    this.ballotDocumentationService.download(this.operation.id, element.id).subscribe(blob &#x3D;&gt; {
      this.fileService.downloadBlob(element.fileName, blob)
    });
    e.preventDefault();
  }

  canDeleteFile(element: BallotDocumentation) {
    let userManagementEntity &#x3D; this.authorizationService.userSnapshot.managementEntity;
    return (userManagementEntity &#x3D;&#x3D;&#x3D; this.operation.managementEntity ||
            userManagementEntity &#x3D;&#x3D;&#x3D; element.managementEntity);
  }

  deleteFile(element: BallotDocumentation) {
    this.dialogService.openConfirm({
      message: this.translateService.instant(&#x27;parameters.ballot-documentation.edit.delete-dialog.message&#x27;, element),
      disableClose: true,
      cancelButton: this.translateService.instant(&#x27;global.actions.no&#x27;),
      acceptButton: this.translateService.instant(&#x27;global.actions.yes&#x27;),
    }).afterClosed().subscribe((accept: boolean) &#x3D;&gt; {
      if (accept) {
        this.ballotDocumentationService.remove(this.operation.id, element.id).subscribe(() &#x3D;&gt; {
          this.snackBar.open(
            this.translateService.instant(
              &#x27;parameters.ballot-documentation.edit.delete-success&#x27;),
            &#x27;&#x27;,
            {duration: 5000}
          );
          this.updateDataSource(this.ballotDocumentations.filter(bd &#x3D;&gt; bd.id !&#x3D;&#x3D; element.id));
        });
      }
    });
  }
}

class BallotDocumentationDataSource extends DataSource&lt;BallotDocumentation&gt; {

  constructor(private translateService: TranslateService, private ballotDocumentations: BallotDocumentation[],
              private sort: MatSort) {
    super();
  }

  connect(): Observable&lt;BallotDocumentation[]&gt; {
    return of(this.ballotDocumentations)
      .pipe(
        merge(this.sort.sortChange),
        map(() &#x3D;&gt; this.ballotDocumentations.map(
          bdoc &#x3D;&gt; Object.assign({}, bdoc, {
            language: this.translateService.instant(
              &#x60;parameters.ballot-documentation.edit.form.fields.language.label-key.${bdoc.language}&#x60;)
          })
        )),
        map((data) &#x3D;&gt; sortOnProperty(data, this.sort.active, this.sort.direction)));
  }

  disconnect() {
  }
}

</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'BallotDocumentationDataSource.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
